#include <hmg.ch>

Function Main()
Private aRows1 [21] [3], aRows2 [0] [4], aRows3 [0] [2]

aRows1  [1]  := {'Simpson',  'Homer',    '555-5555'}
aRows1  [2]  := {'Mulder',   'Fox',      '324-6432'}
aRows1  [3]  := {'Smart',    'Max',      '432-5892'}
aRows1  [4]  := {'Grillo',   'Pepe',     '894-2332'}
aRows1  [5]  := {'Kirk',     'James',    '346-9873'}
aRows1  [6]  := {'Barriga',  'Carlos',   '394-9654'}
aRows1  [7]  := {'Flanders', 'Ned',      '435-3211'}
aRows1  [8]  := {'Smith',    'John',     '123-1234'}
aRows1  [9]  := {'Pedemonti','Flavio',   '000-0000'}
aRows1 [10]  := {'Gomez',    'Juan',     '583-4832'}
aRows1 [11]  := {'Fernandez','Raul',     '321-4332'}
aRows1 [12]  := {'Borges',   'Javier',   '326-9430'}
aRows1 [13]  := {'Alvarez',  'Alberto',  '543-7898'}
aRows1 [14]  := {'Gonzalez', 'Ambo',     '437-8473'}
aRows1 [15]  := {'Batistuta','Gol',      '485-2843'}
aRows1 [16]  := {'Vinazzi',  'Amigo',    '394-5983'}
aRows1 [17]  := {'Pedemonti','Flavio',   '534-7984'}
aRows1 [18]  := {'Samarbide','Armando',  '854-7873'}
aRows1 [19]  := {'Pradon',   'Alejandra','???-????'}
aRows1 [20]  := {'Reyes',    'Monica',   '432-5836'}
aRows1 [21]  := {'Fernndez','Vicente',  '000-0000'}

EnableDragAndDrop()

DEFINE WINDOW Form_1 ;
	AT 0,0 ;
	WIDTH 426 ;
	HEIGHT 650 ;
	TITLE 'Grid Events Demo - Drag Demo Form 1' ;
	MAIN NOSIZE
   
	@ 10,10 GRID Grid_1 ;
		WIDTH 400 ;
		HEIGHT 330 ;
		HEADERS {'Column 1','Column 2','Column 3'} ;
		WIDTHS {120,120,120} ;
		ITEMS aRows1 ;
		VALUE {1,1} ;
		ON GOTFOCUS Drag_F1_G1() ;
		ON HEADCLICK { {||MsgInfo('Click 1')} , {||MsgInfo('Click 2')} , {||MsgInfo('Click 3')} } ;
		MULTISELECT //;
		//CELLNAVIGATION

		@ 360,10 LISTBOX List_1 ;
		WIDTH 120 ;
		HEIGHT 250 ;
		ITEMS { '01','02','03','04','05','06','07','08','09','10' } ;
		ON GOTFOCUS drag_F1_List()
		
		@ 360,140 LISTBOX List_2 ;
		WIDTH 120 ;
		HEIGHT 250 ;
		ITEMS { 'AA','BB','CC','DD','EE','FF','GG','HH','II','JJ' } ;
		ON GOTFOCUS drag_F1_List();
		DRAGITEMS 
		
		@ 360,270 LISTBOX List_3 ;
		WIDTH 120 ;
		HEIGHT 250 ;
		ITEMS { 'I','II','III','IV','V','VI','VII','VIII','IX','X' } ;
		ON GOTFOCUS drag_F1_List();
		MULTISELECT

END WINDOW

DEFINE WINDOW Form_2 ;
	AT 0,435 ;
	WIDTH 426 ;
	HEIGHT 650 ;
	TITLE 'Grid Events Demo - Drag Demo Form 2'
   
	@ 10,10 GRID Grid_1 ;
		WIDTH 400 ;
		HEIGHT 330 ;
		HEADERS {'Column A','Column B','Column C','Column D'} ;
		WIDTHS {120,120,120,120} ;
		ITEMS aRows2 ;
		VALUE {1,1} ;
		ON GOTFOCUS Drag_F2_G1() ;
		CELLNAVIGATION
        
	@ 360, 10 TEXTBOX Text_1 ;
		HEIGHT 24 ;
		WIDTH  120 ;
          VALUE "Text 1";
          ON GOTFOCUS drag_F2_TXT()
        
    @ 360, 140 TEXTBOX Text_2 ;
		HEIGHT 24 ;
		WIDTH  120 ;
		VALUE "Text 2" ;
		ON GOTFOCUS drag_F2_TXT() 

    @ 390, 10 EDITBOX Edit_1 ;
      	WIDTH  120 ;
      	HEIGHT 80 ;
      	VALUE "Edit Box 1";
      	ON GOTFOCUS drag_F2_TXT()
        
    @ 390, 140 EDITBOX Edit_2 ;
      	WIDTH  120 ;
      	HEIGHT 80 ;
      	VALUE "Edit Box 2";
      	ON GOTFOCUS drag_F2_TXT()

    @ 480, 10 RICHEDITBOX RichEdit_1 ;
      	WIDTH  120 ;
      	HEIGHT 80 ;
      	VALUE "Rich Edit Box 1" ;
      	ON GOTFOCUS drag_F2_TXT()
        
    @ 480, 140 RICHEDITBOX RichEdit_2 ;
       	WIDTH  120 ;
       	HEIGHT 80 ;
       	VALUE "Rich Edit Box 2" ;
       	ON GOTFOCUS drag_F2_TXT()
		
	@ 360, 290 BUTTON Button_1 ;
		CAPTION IF( !isEnableDragAndDrop (), 'Enable', 'Disable') + CRLF + 'Drag&&Drop' ;
		ACTION (IF( !isEnableDragAndDrop (), EnableDragAndDrop(), DisableDragAndDrop()), ; 	
				This.CAPTION:=IF( !isEnableDragAndDrop (), 'Enable', 'Disable') + CRLF + 'Drag&&Drop' )  ;
		WIDTH 80 HEIGHT 50 ;
		MULTILINE

END WINDOW

DEFINE WINDOW Form_3 ;
    AT 0,860 ;
    WIDTH 326 ;
    HEIGHT 395 ;
    TITLE 'Grid Events Demo - Drag Demo Form 3'
   
    @ 10,10 GRID Grid_1 ;
        WIDTH 300 ;
        HEIGHT 330 ;
        HEADERS {'Column I','Column II'} ;
        WIDTHS {120,120} ;
        ITEMS aRows3 ;
        VALUE {1,1} ;
        ON GOTFOCUS Drag_F3_G1() ;
        CELLNAVIGATION

END WINDOW

ACTIVATE WINDOW Form_1, Form_2, Form_3

Return Nil
****************************
FUNCTION drag_F2_TXT()
IF HMG_Is_DaD() .AND. !HMG_Is_GridHeaderDaD() 		//.AND. HMG_DaD_Drop_Window()=ThisWindow.Name .AND. HMG_DaD_Drop_Control()=This.Name
	This.Value := HMG_DaD_CellValue()
ENDIF
HMG_Release_DaD()
RETURN
****************************
Function drag_F3_G1()
Local i, aOrder:={}, aNewRowGrid
Local nColDrag := HMG_DaD_DragCellCol()
Local nColDrop := HMG_DaD_DropCellCol()
Local nRowDrag := HMG_DaD_DragCellRow()
Local nRowDrop := HMG_DaD_DropCellRow()
Local cDragFName := HMG_DaD_Drag_Window()
Local cDragCName := HMG_DaD_Drag_Control()
Local cDropFName := HMG_DaD_Drop_Window()
Local cDropCName := HMG_DaD_Drop_Control()
Local aVal := HMG_DaD_Value() 				//dropped value
Local CellVal := HMG_DaD_CellValue()		//dropped Cellvalue

IF IsControlContextMenuDefined( 'Grid_1', 'Form_3' )
	ReleaseControlContextMenu( 'Grid_1', 'Form_3' )
ENDIF

DO CASE
	CASE HMG_Is_DaD() .AND. !HMG_Is_GridHeaderDaD() .AND. cDragFName = 'Form_1' .AND. cDragCName = 'Grid_1'  //support drag from form_1 and grid_1 only
	
		IF HMG_Is_RButtonDaD()			//DragAndDrop with Right button
			DEFINE CONTROL CONTEXTMENU Grid_1 OF Form_3
				IF nRowDrop > 0
					ITEM "Copy && Replace Row" ACTION GridUPD( 'Form_3', 'Grid_1', aVal , nRowDrop , 0 /* mode: 0=replace; 1=add/insert */)
				ENDIF
				ITEM "Copy && Add/Insert Row" ACTION GridUPD( 'Form_3', 'Grid_1', aVal , nRowDrop , 1 /* mode: 0=replace; 1=add/insert */)
				ITEM "Move && Add/Insert Row" ACTION (GridUPD( 'Form_3', 'Grid_1', aVal , nRowDrop , 1 /* mode: 0=replace; 1=add/insert */) ,;
											DoMethod( cDragFName, cDragCName , "DeleteItem" ,  nRowDrag ) )
			END MENU
		ELSE
			//drop row data	
			GridUPD( 'Form_3', 'Grid_1', aVal , nRowDrop, 1 /* mode: 0=replace; 1=add/insert */)
		ENDIF
		
	CASE HMG_Is_DaD() .AND. HMG_Is_GridHeaderDaD() .AND. ;
		cDragFName='Form_3' .AND. cDragCName='Grid_1'
	
		//drag and dropped on the same grid -> change column order
		IF nColDrag # nColDrop		//drag adn drop on different columns
			aOrder:=ARRAY ( Form_3.Grid_1.ColumnCOUNT )
			FOR i = 1 TO LEN( aOrder )
				aOrder [Form_3.Grid_1.ColumnDISPLAYPOSITION (i)] := i 
			NEXT i
			
			i := IF(ASCAN ( aOrder, nColDrag ) < ASCAN ( aOrder, nColDrop ), 1, 0 )		//determine drag left to right or right to left
			
			HB_ADel ( aOrder, ASCAN ( aOrder, nColDrag ), .T.)
			HB_AIns( aOrder, ASCAN ( aOrder, nColDrop ) + i, nColDrag, .T. )
			
			Form_3.Grid_1.DisableUpdate()
			FOR i = 1 TO LEN( aOrder )
				Form_3.Grid_1.ColumnDISPLAYPOSITION ( aOrder [i] ) := i 
			NEXT
			
			Form_3.Grid_1.EnableUpdate()
			Form_3.Grid_1.Refresh
		
		ENDIF
		
	CASE HMG_Is_DaD() .AND. HMG_Is_GridHeaderDaD() .AND. ;
		cDragFName='Form_1' .AND. cDragCName='Grid_1'
	
		//drag and dropped from Form_1 -> add dragged column
		IF nColDrop = 0 		//Dropped on empty column of grid header -> new column 
			nColDrop := This.ColumnCOUNT + 1
		ENDIF
		This.AddColumnEx ( nColDrop , ;
			GetProperty(cDragFName, cDragCName, 'ColumnHEADER', nColDrag) /* [ cCaption ] */, ;
			GetProperty(cDragFName, cDragCName, 'ColumnWIDTH' , nColDrag) /* [ nWidth ] */ , ;
			GetProperty(cDragFName, cDragCName, 'ColumnJUSTIFY' , nColDrag) /* [ nJustify ] */ , ; 
			GetProperty(cDragFName, cDragCName, 'ColumnCONTROL' , nColDrag) /* [aColumnControl] */  )
		//ADD ITEMS
		aNewRowGrid := ARRAY (This.ColumnCOUNT)
		FOR i=1 TO LEN( aNewRowGrid )
			aNewRowGrid [i] :=''
		NEXT i
		FOR i=1 TO GetProperty(cDragFName, cDragCName, 'ItemCount')
			IF This.ItemCount < i
				This.AddItemEx ( aNewRowGrid , i)
			ENDIF
			This.CellEx ( i, nColDrop ) := GetProperty(cDragFName, cDragCName, 'CellEx', i, nColDrag)
		NEXT i
ENDCASE

HMG_Release_DaD()
RETURN
****************************
FUNCTION GridUPD( cFormName, cCtrlName, aValue, nRow, nMode )
LOCAL i, aRowGrid := {}, j
DEFAULT nMode:=1

//multiselect supported, that aVal is multidimentional array

IF nMode == 0
	//replace
	FOR j=1 TO LEN( aValue )
		FOR i=1 TO GetProperty( cFormName, cCtrlName, "ColumnCOUNT")
			IF i <= LEN( aValue [j])
				SetProperty( cFormName, cCtrlName, "CellEx", nRow, i, aValue [j][i] )
			ELSE
				EXIT
			ENDIF
		NEXT i
		nRow ++
	NEXT j

ELSE
	//add/insert
	FOR j=IF( nRow == 0, 1, LEN( aValue) ) TO IF( nRow == 0, LEN( aValue), 1) STEP IF( nRow == 0, 1, -1)
		FOR i=1 TO GetProperty( cFormName, cCtrlName, "ColumnCOUNT")
			IF i <= LEN( aValue [j])
				AADD( aRowGrid, aValue [j] [i] )
			ELSE
				AADD( aRowGrid, Nil )
			ENDIF
		NEXT i
		DoMethod( cFormName,;
		  	cCtrlName,;
		  	"AddItemEx",;
			aRowGrid,;
			IF( nRow = 0, GetProperty(cFormName, cCtrlName, "ItemCount") + 1 , nRow ) )
		aRowGrid := {}
	NEXT j
ENDIF
If IsControlContextMenuDefined( 'Grid_1', 'Form_3' )
	ReleaseControlContextMenu( 'Grid_1', 'Form_3' )
Endif

RETURN 

****************************
function drag_F1_G1()
Local i, aOrder:={}
Local nColDrag := HMG_DaD_DragCellCol()
Local nColDrop := HMG_DaD_DropCellCol()
Local cDragFName := HMG_DaD_Drag_Window()
Local cDragCName := HMG_DaD_Drag_Control()
Local cDropFName := HMG_DaD_Drop_Window()
Local cDropCName := HMG_DaD_Drop_Control()

DO CASE
	CASE HMG_Is_DaD() .AND. HMG_Is_GridHeaderDaD() .AND. ;
		cDragFName='Form_1' .AND. cDragCName='Grid_1'
	
		//drag and dropped on the same grid -> change column order
		IF nColDrag # nColDrop		//drag adn drop on different columns
			aOrder:=ARRAY ( Form_1.Grid_1.ColumnCOUNT )
			FOR i = 1 TO LEN( aOrder )
				aOrder [Form_1.Grid_1.ColumnDISPLAYPOSITION (i)] := i 
			NEXT i
			
			i := IF(ASCAN ( aOrder, nColDrag ) < ASCAN ( aOrder, nColDrop ), 1, 0 )		//determine drag left to right or right to left
			
			HB_ADel ( aOrder, ASCAN ( aOrder, nColDrag ), .T.)
			HB_AIns( aOrder, ASCAN ( aOrder, nColDrop ) + i, nColDrag, .T. )
			
			Form_1.Grid_1.DisableUpdate()
			FOR i = 1 TO LEN( aOrder )
				Form_1.Grid_1.ColumnDISPLAYPOSITION ( aOrder [i] ) := i 
			NEXT
			
			Form_1.Grid_1.EnableUpdate()
			Form_1.Grid_1.Refresh
		
		ENDIF
		
ENDCASE
HMG_Release_DaD()

RETURN


****************************
function drag_F2_G1()
Local aRowGrid [this.ColumnCOUNT ] , aNewRowGrid , i, aOrder:={}
Local nColDrag := HMG_DaD_DragCellCol()
Local nColDrop := HMG_DaD_DropCellCol()
Local nRowDrag := HMG_DaD_DragCellRow()
Local nRowDrop := HMG_DaD_DropCellRow()
Local cDragFName := HMG_DaD_Drag_Window()
Local cDragCName := HMG_DaD_Drag_Control()
Local cDropFName := HMG_DaD_Drop_Window()
Local cDropCName := HMG_DaD_Drop_Control()
Local aVal := HMG_DaD_Value() 				//dropped value
Local CellVal := HMG_DaD_CellValue()		//dropped Cellvalue


DO CASE
	CASE HMG_Is_DaD() .AND. !HMG_Is_GridHeaderDaD()

		IF (cDragFName='Form_1' .AND. cDragCName='Grid_1') .OR. cDragFName='Form_2'		//support drag from form_1 and grid_1 and whole form_2 (even itself drag) 
		
			//drop cell data
			IF nRowDrop == 0		//add
				nRowDrop := Form_2.Grid_1.ItemCount + 1
				nColDrop := 1
				Form_2.Grid_1.AddItemEx ( aRowGrid, nRowDrop )
			ENDIF
			Form_2.Grid_1.CellEx ( nRowDrop, nColDrop ) := CellVal

		ENDIF
	
		IF cDragFName='Form_1' .AND. (cDragCName='List_1' .OR. cDragCName='List_2' .OR. cDragCName='List_3')		//support drag from form_1 and listbox
		
			FOR i=LEN( aVal ) TO 1 STEP -1 
				IF nRowDrop == 0		//add
					nRowDrop := Form_2.Grid_1.ItemCount + 1
					nColDrop := 1
				ENDIF
				Form_2.Grid_1.AddItemEx ( aRowGrid, nRowDrop )
				Form_2.Grid_1.CellEx ( nRowDrop, nColDrop ) := aVal [i][1]
			NEXT i

		ENDIF


	CASE HMG_Is_DaD() .AND. HMG_Is_GridHeaderDaD() .AND. ;
		cDragFName='Form_2' .AND. cDragCName='Grid_1'
	
		//drag and dropped on the same grid -> change column order
		IF nColDrag # nColDrop		//drag adn drop on different columns
			aOrder:=ARRAY ( Form_2.Grid_1.ColumnCOUNT )
			FOR i = 1 TO LEN( aOrder )
				aOrder [Form_2.Grid_1.ColumnDISPLAYPOSITION (i)] := i 
			NEXT i
			
			i := IF(ASCAN ( aOrder, nColDrag ) < ASCAN ( aOrder, nColDrop ), 1, 0 )		//determine drag left to right or right to left
			
			HB_ADel ( aOrder, ASCAN ( aOrder, nColDrag ), .T.)
			HB_AIns( aOrder, ASCAN ( aOrder, nColDrop ) + i, nColDrag, .T. )
			
			Form_2.Grid_1.DisableUpdate()
			FOR i = 1 TO LEN( aOrder )
				Form_2.Grid_1.ColumnDISPLAYPOSITION ( aOrder [i] ) := i 
			NEXT
			
			Form_2.Grid_1.EnableUpdate()
			Form_2.Grid_1.Refresh
		
		ENDIF
		
	CASE HMG_Is_DaD() .AND. HMG_Is_GridHeaderDaD() .AND. ;
		cDragFName='Form_1' .AND. cDragCName='Grid_1'
	
		//drag and dropped from Form_1 -> add dragged column
		IF nColDrop = 0 		//Dropped on empty column of grid header -> new column 
			nColDrop := This.ColumnCOUNT + 1
		ENDIF
		This.AddColumnEx ( nColDrop , ;
			GetProperty(cDragFName, cDragCName, 'ColumnHEADER', nColDrag) /* [ cCaption ] */, ;
			GetProperty(cDragFName, cDragCName, 'ColumnWIDTH' , nColDrag) /* [ nWidth ] */ , ;
			GetProperty(cDragFName, cDragCName, 'ColumnJUSTIFY' , nColDrag) /* [ nJustify ] */ , ; 
			GetProperty(cDragFName, cDragCName, 'ColumnCONTROL' , nColDrag) /* [aColumnControl] */  )
		//ADD ITEMS
		aNewRowGrid := ARRAY (This.ColumnCOUNT)
		FOR i=1 TO LEN( aNewRowGrid )
			aNewRowGrid [i] :=''
		NEXT i
		FOR i=1 TO GetProperty(cDragFName, cDragCName, 'ItemCount')
			IF This.ItemCount < i
				This.AddItemEx ( aNewRowGrid , i)
			ENDIF
			This.CellEx ( i, nColDrop ) := GetProperty(cDragFName, cDragCName, 'CellEx', i, nColDrag)
		NEXT i
		

ENDCASE
HMG_Release_DaD()

RETURN

****************************
function drag_F1_List()
Local i
Local aVal := HMG_DaD_Value() 				//dropped value
Local CellVal := HMG_DaD_CellValue() 				//dropped value
Local cDragFName := HMG_DaD_Drag_Window()
Local cDragCName := HMG_DaD_Drag_Control()
Local cDropFName := HMG_DaD_Drop_Window()
Local cDropCName := HMG_DaD_Drop_Control()

IF HMG_Is_DaD() .AND. !HMG_Is_GridHeaderDaD() 

	IF cDragFName='Form_1'		//support drag whole form_1
		FOR i=1 TO LEN( aVal ) 
			DoMethod (cDropFName, cDropCName, 'AddItem' , hb_ValToStr(aVal [i][1]) )
		NEXT i
	ENDIF
	
	IF (cDragFName='Form_2' .AND. cDragCName='Grid_1')		//support drag from form_2 and grid_1
		DoMethod (cDropFName, cDropCName, 'AddItem' , hb_ValToStr(CellVal) )
	ENDIF
ENDIF
HMG_Release_DaD()

RETURN 